<?php
namespace Ak\Form\Annotation;

use Laminas\EventManager\EventInterface;
use Laminas\Form\Annotation\Name;

/**
 * Trait AnnotationsListenerTrait
 *
 * @package Ak\Form\Annotation
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/form
 */
trait AnnotationsListenerTrait
{
    /**
     * Attempt to discover a name set via annotation
     *
     * @param  EventInterface $e
     * @return false|string
     */
    public function handleNameAnnotation(EventInterface $e)
    {
        $annotations = $e->getParam('annotations');

        foreach ($annotations as $annotation) {
            if ($annotation instanceof Name) {
                return $annotation->getName();
            }
        }

        return false;
    }
}
